package com.uoc.pfc.catalogoweb.media;

import java.awt.BorderLayout;
import java.awt.Component;
import java.io.IOException;
import java.net.URL;

import javax.media.CannotRealizeException;
import javax.media.Manager;
import javax.media.NoPlayerException;
import javax.media.Player;
import javax.swing.JPanel;



public class MediaPanel extends JPanel {
	
	 /**
	 * 
	 */
	private static final long serialVersionUID = -6120975292707517087L;

	public MediaPanel( URL mediaURL )
	 {
	 setLayout( new BorderLayout() ); // use a BorderLayout
	 	 
	// Uso de componentes sencillos
	 Manager.setHint( Manager.LIGHTWEIGHT_RENDERER, true );
	  
	 	          try
	 	          {
	 	             // crear un reproductor para la URl especifica
	 	             Player mediaPlayer = Manager.createRealizedPlayer( mediaURL );
	 	 
	 	             // componentes de interfaz para el mostrar el video y controles
	 	             Component video = mediaPlayer.getVisualComponent();
	 	             Component controls = mediaPlayer.getControlPanelComponent();
	 	 
	 	             if ( video != null )
	 	                // agragar el video al componente
	 	                add( video, BorderLayout.CENTER );
	 	 
	 	             if ( controls != null )
	 	                // agregar controles
	 	                add( controls, BorderLayout.SOUTH );
	 	 
	 	             mediaPlayer.start(); //  reproducir el clip
	 	          }
	 	          catch ( NoPlayerException noPlayerException )
	 	          {
	 	             System.err.println( "No se encontro archivos de multimedia" );
	 	          }
	 	          catch ( CannotRealizeException cannotRealizeException ){
	 	             System.err.println( "No se puede reconocer el reproductor" );
	 	          }
	 	          catch ( IOException iOException ){
	 	             System.err.println( "Error al leer la fuente" );
	 	          }
	 	       }
	
	

}
