package com.uoc.pfc.catalogoweb.service;

import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.ResourceBundle;

import javax.sql.DataSource;

public class IbatisDataSource implements DataSource {
	
	private PrintWriter writer;
	private int loginTimeout;
	
	public IbatisDataSource() {
		super();
	}
        
	@SuppressWarnings("finally")
	public Connection getConnection() throws SQLException {
        
        ResourceBundle bundle = ResourceBundle.getBundle("DatabaseConnection");
        
        String driver = bundle.getString("connection.driver");
        String url = bundle.getString("connection.url");
        String user = bundle.getString("connection.user");
        String password = bundle.getString("connection.password");
       
        Connection connection = null;
        try {
            Class.forName(driver).newInstance();
            connection = DriverManager.getConnection(url, user, password);
        } catch (Exception e) {
        	e.printStackTrace();
            throw new SQLException(e.getMessage());
        } finally {
        	return connection;
        }
	}

	public Connection getConnection(String user, String pass) 
		throws SQLException {
		return getConnection();
	}

	public int getLoginTimeout() throws SQLException {
		return loginTimeout;
	}

	public PrintWriter getLogWriter() throws SQLException {
		return writer;
	}

	public void setLoginTimeout(int seconds) throws SQLException {
		loginTimeout = seconds;
	}

	public void setLogWriter(PrintWriter out) throws SQLException {
		writer = out;
	}

}
