package com.uoc.pfc.catalogoweb.service.dao;

/**
 * Interface DAO
 */
public interface DAO {
    
    /**
     * Abrir la conexin a la base de datos por defecto
     */
    public void open() throws DAOException;
        
    /**
     * Abrir la conexin a una base de datos
     */
    public void open(String aName) throws DAOException;
        
    /**
     * Cerrar la conexin a la base de datos
     */
    public void close() throws DAOException;
        
    /**
     * Iniciar transaccin
     */
    public void beginTransaction() throws DAOException;
    
    /**
     * Realizar el commit de la transaccin
     */
    public void commitTransaction() throws DAOException;
    
    /**
     * Realizar el rollback de la transaccin
     */
    public void rollbackTransaction() throws DAOException;
        
    /**
     * Funcin que devuelve si est abierta una transaccion
     */
    public boolean isInTransaction() throws DAOException;
    
    /**
     * Funcin que pasa al DAO la transaccin a usar
     */
    public void setTransaction(Object aTransaction) throws DAOException;
    
    /**
     * Funcin que retorna la transaccin actual utilizada por el DAO
     */
    public Object getTransaction() throws DAOException;    
    
}
