package com.uoc.pfc.catalogoweb.service.dao;

/**
 * Clase excepcin de acceso a datos.
 */
public class DAOException extends Exception {

    /**
	 * serialVersionUID
	 */
	private static final long serialVersionUID = 2343821974772241050L;

	/**
     * Causa raz de la excepcin. La excepcin recibida previamente
     */
    private Throwable rootCause = null;
    
    /**
     * Clave del mensaje de la excepcin
     */
    private String messageKey = null;

    /**
     * Argumentos del mensaje de la excepcin
     */
    private Object[] messageArgs = null;

    /**
     * Argumentos del mensaje de la excepcin
     */
    private Object messageObject = null;

    /**
     * Constructor for DAOException
     */
    public DAOException(Throwable aRootException) {
    	rootCause = aRootException;
    }

    /**
     * Constructor for DAOException
     */
    public DAOException(Throwable aRootException, String aMessageKey) {
    	rootCause = aRootException;
    	messageKey = aMessageKey;
    }

    /**
     * Constructor for DAOException
     */
    public DAOException(String aMessageKey) {
    	messageKey = aMessageKey;
    }

    /**
     * Constructor for DAOException
     */
    public DAOException(String aMessageKey, Object[] args) {
    	messageKey = aMessageKey;
    	messageArgs = args;
    }

    /**
     * Constructor for DAOException
     */
    public DAOException(
            Throwable aRootException,
            String aMessageKey,
            Object aMessageObject) {
    	
    	rootCause = aRootException;
    	messageKey = aMessageKey;
    	messageObject = aMessageObject;
    }    
    
    /**
     * Constructor for DAOException
     */
    public DAOException(
            Throwable aRootException,
            String aMessageKey,
            Object[] aMessageArgs) {
    	
    	rootCause = aRootException;
    	messageKey = aMessageKey;
    	messageArgs = aMessageArgs;
    }    
}
