package com.uoc.pfc.catalogoweb.service.ibatis;

import com.uoc.pfc.catalogoweb.service.IbatisDataSource;
import java.util.Map;

import javax.sql.DataSource;

import com.ibatis.sqlmap.engine.datasource.DataSourceFactory;

/**
 * Factoria de DataSources para proporcionar un DS que devuelva las
 * conexiones del IbatisDataSource.
 * 
 */
public class IbatisDataSourceFactory implements DataSourceFactory {

	/** DataSource que devolver las conexiones */
	private IbatisDataSource ds;

	/**
	 * Devuelve el DataSource asociado a la factoria
	 * @return el dataSource
	 */
	public DataSource getDataSource() {
		return ds;
	}

	/**
	 * Inicializa la factoria
	 * @param map parametros de inicializacin de la factoria
	 */
	public void initialize(Map map) {
		ds = new IbatisDataSource();
	}

}
