package test;

import java.util.Collection;

import com.uoc.pfc.catalogoweb.bean.FilmVO;
import com.uoc.pfc.catalogoweb.bean.SongVO;
import com.uoc.pfc.catalogoweb.service.dao.DAOException;
import com.uoc.pfc.catalogoweb.service.dao.LibreriaMusicalDAOImpl;
import com.uoc.pfc.catalogoweb.service.dao.VideoclubDAOImpl;

public class TestIbatis {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		

		testLibreriaMusical();
		testVideoClub();
		testInterpretes();
		
		
	}

	private static void testLibreriaMusical() {
	
		LibreriaMusicalDAOImpl test = new LibreriaMusicalDAOImpl();
	
		Collection<SongVO> result = null;
		
	    try {
    		SongVO song = new SongVO();
    		song.setTitulo("The Time");
    		
            result = test.getSongs(song);
            
            if ((result != null) && (!result.isEmpty())) {
            	System.out.println("El resultado obtenido es correcto:");
            	System.out.println(result.iterator().next().getTitulo());
            	System.out.println(result.iterator().next().getInterprete());
            } else {
            	System.out.println("El resultado obtenido es FALLIDO");
            }
	
	    } catch (DAOException e) {
	
	    	System.out.println("Error SQL en prueba Ibatis: " + e);
	    	e.printStackTrace();
	    }
	}

	
	private static void testVideoClub() {
		
		VideoclubDAOImpl test = new VideoclubDAOImpl();
		
		Collection<FilmVO> result = null;
		
	    try {
	    	FilmVO film = new FilmVO();
	    	film.setTituloOriginal("Troya");
    		
            result = test.getFilms(film);
            
            if ((result != null) && (!result.isEmpty())) {
            	System.out.println("El resultado obtenido es correcto:");
            	System.out.println(result.iterator().next().getTitulo());
            	System.out.println(result.iterator().next().getProductora());
            } else {
            	System.out.println("El resultado obtenido es FALLIDO");
            }
	
	    } catch (DAOException e) {
	
	    	System.out.println("Error SQL en prueba Ibatis: " + e);
	    	e.printStackTrace();
	    }
	}

	
	private static void testInterpretes() {
		
		VideoclubDAOImpl test = new VideoclubDAOImpl();
		
		Collection<String> result = null;
		
	    try {
	    	   		
            result = test.getInterpretes(2);
            
            if ((result != null) && (!result.isEmpty())) {
            	System.out.println("El resultado obtenido es correcto:");
            	System.out.println(result.iterator().next());
            	
            } else {
            	System.out.println("El resultado obtenido es FALLIDO");
            }
	
	    } catch (DAOException e) {
	
	    	System.out.println("Error SQL en prueba Ibatis: " + e);
	    	e.printStackTrace();
	    }
	}

}
